#!/bin/bash
SSH_PORT=${SSH_PORT:-22}
if [[ ! -z "$SSH_KEY" ]]; then
    echo "SSH Key found. Prepare SSH agent."
    eval $(ssh-agent -s)
    if [[ -f "$SSH_KEY" ]]; then
        cat "$SSH_KEY" | tr -d '\r' | ssh-add -
    else
        echo "$SSH_KEY" | tr -d '\r' | ssh-add -
    fi
else
    echo "No SSH key found. Skip prepare."
fi

mkdir -p ~/.ssh
chmod 700 ~/.ssh

if [[ ! -z "$SSH_HOST" ]]; then
    echo "SSH Host found. Prepare known_hosts."
    ssh-keyscan -p $SSH_PORT $SSH_HOST > ~/.ssh/known_hosts
    chmod 644 ~/.ssh/known_hosts
fi

exec "$@"
